unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Controls, Forms,
  Dialogs, VFW, StdCtrls, Graphics, AVIWriter, OpenGl, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    RadioGroup1: TRadioGroup;
    SaveDialog1: TSaveDialog;
    GroupBox1: TGroupBox;
    Panel1: TPanel;
    Edit1: TEdit;
    UpDown1: TUpDown;
    Panel2: TPanel;
    Edit2: TEdit;
    UpDown2: TUpDown;
    Panel3: TPanel;
    Edit3: TEdit;
    UpDown3: TUpDown;
    AVIWriter1: TAVIWriter;
    Panel4: TPanel;
    ComboBox1: TComboBox;
    ProgressBar1: TProgressBar;
    CheckBox1: TCheckBox;
    Panel5: TPanel;
    ColorBox1: TColorBox;
    RadioGroup2: TRadioGroup;
    procedure Button1Click(Sender: TObject);
    procedure AVIWriter1FrameAdd(Sender: TObject);
  private
  public
    procedure RecordBitmaps;
    procedure RecordDesktop;
    procedure RecordMouse;
    procedure RecordOpenGl;
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  if SaveDialog1.Execute then begin
    ProgressBar1.Position:=0;
    ProgressBar1.Max:=UpDown3.Position;
    AVIWriter1.AVIFileName:=SaveDialog1.FileName;
    AVIWriter1.AVIWidth:=UpDown1.Position;
    AVIWriter1.AVIHeight:=UpDown2.Position;
    AVIWriter1.ResamplingMethod:=TResamplingMethod(ComboBox1.ItemIndex);
    AVIWriter1.AVIRealTime:=CheckBox1.Checked;
    AVIWriter1.AVIBackGroundColor:=ColorBox1.Selected;
    AVIWriter1.AVIPixelFormat:=TAVIPixelFormat(RadioGroup2.ItemIndex);
    AVIWriter1.StartRecording;
    try
      case RadioGroup1.ItemIndex of
        0:RecordBitmaps;
        1:RecordDesktop;
        2:RecordMouse;
        3:RecordOpenGl;
      end;
    finally
      AVIWriter1.StopRecording;
    end;
  end;
end;

procedure TForm1.RecordBitmaps;
var
  p:TBitmap;
  a:Integer;
begin
  p:=TBitmap.Create;
  p.Width:=200;
  p.Height:=200;
  for a:=1 to UpDown3.Position do begin
    p.Canvas.Brush.Color:=Random(256*256*256);
    p.Canvas.Ellipse(50-a,50-a,50+a,50+a);
    AVIWriter1.AddFrameBitmap(p);
  end;
end;

procedure TForm1.RecordDesktop;
var
  DC:HDC;
  a:Integer;
begin
  DC:=GetDC(GetDesktopWindow);
  for a:=1 to UpDown3.Position do begin
    AVIWriter1.AddFrameFromDC(DC,Screen.DesktopRect);
    Sleep(20);
  end;
  ReleaseDC(GetDesktopWindow,DC);
end;

procedure TForm1.RecordMouse;
var
  DC:HDC;
  p:TPoint;
  r:TRect;
  a:Integer;
begin
  DC:=GetDC(GetDesktopWindow);
  for a:=1 to UpDown3.Position do begin
    GetCursorPos(p);
    r.TopLeft:=Point(0,0);
    r.BottomRight:=Point(AVIWriter1.AVIWidth,AVIWriter1.AVIHeight);
    OffsetRect(r,p.X-AVIWriter1.AVIWidth div 2,p.Y-AVIWriter1.AVIHeight div 2);
    AVIWriter1.AddFrameFromDC(DC,r);
    Sleep(20);
  end;
  ReleaseDC(GetDesktopWindow,DC);
end;

procedure TForm1.RecordOpenGl;
var
  p:Pointer;
  a:Integer;
begin
  Form2.Show;
  GetMem(p,3*(AVIWriter1.AVIWidth+1)*AVIWriter1.AVIHeight);
  for a:=1 to UpDown3.Position do begin
    Form2.DrawCube;
    glReadPixels(0,0,Form2.ClientWidth,Form2.ClientHeight,GL_RGB,GL_UNSIGNED_BYTE,p);
    glFlush;
    SwapBuffers(Form2.Canvas.Handle);
    AVIWriter1.AddFrameRawRGB(p,Form2.ClientWidth,Form2.ClientHeight);
  end;
  FreeMem(p);
  Form2.Hide;
end;

procedure TForm1.AVIWriter1FrameAdd(Sender: TObject);
begin
  ProgressBar1.Position:=AVIWriter1.CurrentFrame;
  ProgressBar1.Repaint;
end;

end.
