unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OpenGl;

type
  TForm2 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    FRotation:Single;
  public
    procedure DrawCube;
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

procedure TForm2.DrawCube;
var
  a:Integer;
const
  t:array[0..11,0..1,0..2] of Single=(
    ((-1,-1,-1),(-1, 1,-1)),
    (( 1,-1,-1),( 1, 1,-1)),
    ((-1,-1,-1),( 1,-1,-1)),
    ((-1, 1,-1),( 1, 1,-1)),

    ((-1,-1, 1),(-1, 1, 1)),
    (( 1,-1, 1),( 1, 1, 1)),
    ((-1,-1, 1),( 1,-1, 1)),
    ((-1, 1, 1),( 1, 1, 1)),

    ((-1,-1,-1),(-1,-1, 1)),
    ((-1, 1,-1),(-1, 1, 1)),
    (( 1,-1,-1),( 1,-1, 1)),
    (( 1, 1,-1),( 1, 1, 1))
  );
begin
  FRotation:=FRotation+3;
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity;
  glRotate(FRotation,0,1,0);
  glRotate(FRotation*1.2,1,0,0);
  glRotate(FRotation*1.8,0,0,1);
  glViewport(0,0,ClientWidth,ClientHeight);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  gluPerspective(70,ClientWidth/ClientHeight,0.1,10);
  gluLookAt(0,0,5,0,0,0,0,1,0);
  glClearColor(0,0,0,0);
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glColor3f(1,1,1);
  glBegin(GL_LINES);
  for a:=0 to High(T) do begin
    glVertex3f(T[a,0,0],T[a,0,1],T[a,0,2]);
    glVertex3f(T[a,1,0],T[a,1,1],T[a,1,2]);
  end;
  glEnd;

end;

procedure TForm2.FormCreate(Sender: TObject);
var
  PFD:TPixelFormatDescriptor;
  c:Integer;
  GLRC:HGLRC;
begin
  ZeroMemory(@PFD,SizeOf(PFD));
  with PFD do begin
    nSize:=SizeOf(PFD);
    nVersion:=1;
    dwFlags:=PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER;
    iPixelType:=PFD_MAIN_PLANE or PFD_TYPE_RGBA;
    cColorBits:=GetDeviceCaps(Canvas.Handle,BITSPIXEL);
    cDepthBits:=16;
  end;
  c:=ChoosePixelFormat(Canvas.Handle,@PFD);
  SetPixelFormat(Canvas.Handle,c,@PFD);
  GLRC:=wglCreateContext(Canvas.Handle);
  wglMakeCurrent(Canvas.Handle,GLRC);
end;

end.
 