unit ExtendedCompressorDialogFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Buttons, ExtCtrls, VFW;

type
  TExtendedCompressorDialogForm = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    ListView1: TListView;
    Panel1: TPanel;
    TrackBar1: TTrackBar;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    Panel2: TPanel;
    Edit1: TEdit;
    UpDown1: TUpDown;
    Panel3: TPanel;
    CheckBox1: TCheckBox;
    TrackBar2: TTrackBar;
    Panel4: TPanel;
    Edit2: TEdit;
    UpDown2: TUpDown;
    procedure ListView1Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    FBIH:TBitmapInfoHeader;
    FMode:Cardinal;

    procedure UpdateList;
  public
    function Execute(ABIH:TBitmapInfoHeader;AMode:Cardinal;var Quality,DataRate,FrameRate,MaxFramesBetweenKeys:Cardinal;var AutoKeyFrames:Boolean):HIC;
  end;

var
  ExtendedCompressorDialogForm: TExtendedCompressorDialogForm;

function ExecuteExtendedCompressorDialog(ABIH:TBitmapInfoHeader;AMode:Cardinal;var Quality,DataRate,FrameRate,MaxFramesBetweenKeys:Cardinal;var AutoKeyFrames:Boolean):HIC;

implementation

uses
  AVIWriter;

function ExecuteExtendedCompressorDialog(ABIH:TBitmapInfoHeader;AMode:Cardinal;var Quality,DataRate,FrameRate,MaxFramesBetweenKeys:Cardinal;var AutoKeyFrames:Boolean):HIC;
begin
  if not Assigned(ExtendedCompressorDialogForm) then
    Application.CreateForm(TExtendedCompressorDialogForm,ExtendedCompressorDialogForm);
  Result:=ExtendedCompressorDialogForm.Execute(ABIH,AMode,Quality,DataRate,FrameRate,MaxFramesBetweenKeys,AutoKeyFrames);
end;

{$R *.dfm}

{ TExtendedCompressorDialogForm }

function TExtendedCompressorDialogForm.Execute(ABIH: TBitmapInfoHeader;
  AMode: Cardinal;var Quality, DataRate, FrameRate, MaxFramesBetweenKeys:Cardinal;
  var AutoKeyFrames: Boolean): HIC;
var
  a:Integer;
begin
  Result:=0;
  FBIH:=ABIH;
  FMode:=AMode;
  try
    UpdateList;
    TrackBar1.Position:=Quality div 100;
    TrackBar1Change(nil);
    UpDown1.Position:=DataRate div 1000;
    TrackBar2.Position:=FrameRate;
    TrackBar2Change(nil);
    CheckBox1.Checked:=AutoKeyFrames;
    UpDown2.Position:=MaxFramesBetweenKeys;
    if ShowModal=mrOk then begin
      Quality:=100*TrackBar1.Position;
      DataRate:=UpDown1.Position*1000;
      FrameRate:=TrackBar2.Position;
      AutoKeyFrames:=CheckBox1.Checked;
      MaxFramesBetweenKeys:=UpDown2.Position;
      if ListView1.Selected.Index=0 then
        Result:=GIC_NOCOMPRESS
      else begin
        Result:=ICOpen(ICTYPE_VIDEO,PICInfo(ListView1.Selected.Data).fccHandler,FMode);
        if Result=0 then
          raise EAVIBuilderException.CreateCode(GetLastError,'Cannot open selected video compressor');
      end;
    end;
  finally
    for a:=1 to ListView1.Items.Count-1 do
      Dispose(PICInfo(ListView1.Items[a].Data));
  end;
end;

procedure TExtendedCompressorDialogForm.UpdateList;
var
  i:Integer;
  Info:TICInfo;
  IC:HIC;
  p:PICInfo;
type
  TFourCCString=array[1..4] of Char;
begin
  ListView1.Items.Clear;
  with ListView1.Items.Add do begin
    Caption:='RGB_';
    SubItems.Add('<none>');
    SubItems.Add('No compression');
    SUbItems.Add('');
  end;
  i:=0;
  while ICInfo(ICTYPE_VIDEO,i,@Info) do begin
    IC:=ICOpen(Info.fccType,Info.fccHandler,FMode);
    if (IC<>0) and (ICGetInfo(IC,@Info,SizeOf(Info))<>0) and (ICCompressQuery(IC,@FBIH,nil)=ICERR_OK) then begin
      New(p);
      p^:=Info;
      with ListView1.Items.Add do begin
        Caption:=TFourCCString(Info.fccHandler);
        SubItems.Add(Info.szName);
        SubItems.Add(Info.szDescription);
        SubItems.Add(Info.szDriver);
        Data:=p;
      end;
    end;
    ICClose(IC);
    Inc(i);
  end;
end;

procedure TExtendedCompressorDialogForm.ListView1Change(Sender: TObject;
  Item: TListItem; Change: TItemChange);
var
  IC:HIC;
begin
  if Assigned(ListView1.Selected) and (ListView1.Selected.Index>0) then begin
    BitBtn1.Enabled:=True;
    with PICInfo(ListView1.Selected.Data)^ do begin
      Panel1.Visible:=dwFlags and VIDCF_QUALITY=VIDCF_QUALITY;
      Panel2.Visible:=dwFlags and VIDCF_CRUNCH=VIDCF_CRUNCH;
      IC:=ICOpen(ICTYPE_VIDEO,PICInfo(ListView1.Selected.Data).fccHandler,FMode);
      BitBtn3.Enabled:=ICQueryAbout(IC);
      BitBtn4.Enabled:=ICQueryConfigure(IC);
      ICClose(IC);
    end;
    Panel4.Visible:=CheckBox1.Checked;
  end else begin
    Panel1.Visible:=False;
    Panel2.Visible:=False;
    Panel4.Visible:=False;
    BitBtn1.Enabled:=Assigned(ListView1.Selected);
    BitBtn3.Enabled:=False;
    BitBtn4.Enabled:=False;
  end;
end;

procedure TExtendedCompressorDialogForm.BitBtn4Click(Sender: TObject);
var
  IC:HIC;
begin
  with PICInfo(ListView1.Selected.Data)^ do begin
    IC:=ICOpen(ICTYPE_VIDEO,PICInfo(ListView1.Selected.Data).fccHandler,ICMODE_QUERY);
    ICConfigure(IC,Handle);
    ICClose(IC);
  end;
end;

procedure TExtendedCompressorDialogForm.BitBtn3Click(Sender: TObject);
var
  IC:HIC;
begin
  with PICInfo(ListView1.Selected.Data)^ do begin
    IC:=ICOpen(ICTYPE_VIDEO,PICInfo(ListView1.Selected.Data).fccHandler,ICMODE_QUERY);
    ICAbout(IC,Handle);
    ICClose(IC);
  end;
end;

procedure TExtendedCompressorDialogForm.TrackBar1Change(Sender: TObject);
begin
  Panel1.Caption:='Quality: '+IntToStr(TrackBar1.Position);
end;

procedure TExtendedCompressorDialogForm.ListView1DblClick(Sender: TObject);
begin
  if BitBtn4.Enabled then
    BitBtn4.Click;
end;

procedure TExtendedCompressorDialogForm.TrackBar2Change(Sender: TObject);
begin
  Panel3.Caption:='Frames/s: '+FormatFloat('0.###',TrackBar2.Position/1000);
end;

procedure TExtendedCompressorDialogForm.CheckBox1Click(Sender: TObject);
begin
  Panel4.Visible:=CheckBox1.Checked;
end;

end.
