unit SimpleCompressorDialogFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Buttons, VFW;

type
  TSimpleCompressorDialogForm = class(TForm)
    ComboBox1: TComboBox;
    Panel1: TPanel;
    TrackBar1: TTrackBar;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure TrackBar1Change(Sender: TObject);
  private
    FBIH:TBitmapInfoHeader;
    FMode:Cardinal;

    procedure UpdateList;
  public
    function Execute(ABIH:TBitmapInfoHeader;AMode:Cardinal;var Quality,DataRate,FrameRate,MaxFramesBetweenKeys:Cardinal;var AutoKeyFrames:Boolean):HIC;
  end;

var
  SimpleCompressorDialogForm: TSimpleCompressorDialogForm=nil;

function ExecuteSimpleCompressorDialog(ABIH:TBitmapInfoHeader;AMode:Cardinal;var Quality,DataRate,FrameRate,MaxFramesBetweenKeys:Cardinal;var AutoKeyFrames:Boolean):HIC;

implementation

uses
  AVIWriter;

function ExecuteSimpleCompressorDialog(ABIH:TBitmapInfoHeader;AMode:Cardinal;var Quality,DataRate,FrameRate,MaxFramesBetweenKeys:Cardinal;var AutoKeyFrames:Boolean):HIC;
begin
  if not Assigned(SimpleCompressorDialogForm) then
    Application.CreateForm(TSimpleCompressorDialogForm,SimpleCompressorDialogForm);
  Result:=SimpleCompressorDialogForm.Execute(ABIH,AMode,Quality,DataRate,FrameRate,MaxFramesBetweenKeys,AutoKeyFrames);
end;

{$R *.dfm}

{ TSimpleCompressorDialogForm }

function TSimpleCompressorDialogForm.Execute(ABIH: TBitmapInfoHeader; AMode: Cardinal;
  var Quality, DataRate, FrameRate, MaxFramesBetweenKeys: Cardinal;
  var AutoKeyFrames: Boolean): HIC;
var
  a:Integer;
begin
  Result:=0;
  FBIH:=ABIH;
  FMode:=AMode;
  try
    UpdateList;
    if ShowModal=mrOk then begin
      Quality:=100*TrackBar1.Position;
      if ComboBox1.ItemIndex=0 then
        Result:=GIC_NOCOMPRESS
      else begin
        Result:=ICOpen(ICTYPE_VIDEO,PICInfo(ComboBox1.Items.Objects[ComboBox1.ItemIndex]).fccHandler,FMode);
        if Result=0 then
          raise EAVIBuilderException.CreateCode(GetLastError,'Cannot open selected video compressor');
      end;
    end;
  finally
    for a:=1 to ComboBox1.Items.Count-1 do
      Dispose(PICInfo(ComboBox1.Items.Objects[a]));
  end;
end;

procedure TSimpleCompressorDialogForm.UpdateList;
var
  i:Integer;
  Info:TICInfo;
  IC:HIC;
  p:PICInfo;
begin
  ComboBox1.Items.Clear;
  ComboBox1.Items.AddObject('<none> (no compression)',nil);
  i:=0;
  while ICInfo(ICTYPE_VIDEO,i,@Info) do begin
    IC:=ICOpen(Info.fccType,Info.fccHandler,FMode);
    if (IC<>0) and (ICGetInfo(IC,@Info,SizeOf(Info))<>0) and (ICCompressQuery(IC,@FBIH,nil)=ICERR_OK) then begin
      New(p);
      p^:=Info;
      ComboBox1.Items.AddObject(Info.szDescription,TObject(p));
    end;
    ICClose(IC);
    Inc(i);
  end;
  ComboBox1.ItemIndex:=0;
end;

procedure TSimpleCompressorDialogForm.TrackBar1Change(Sender: TObject);
begin
  Panel1.Caption:='Quality: '+IntToStr(TrackBar1.Position);
end;

end.
